<?php

		 		// Download.php
				//
				// This routine downloads a theme , and runs a basic analysis over it before
				// adding it to the database
				
				function bm_gallery_getthemedir($theme_id)
				{
	 				 // Determine the destination directory 
					 return BM_GALLERY_DIRECTORY . "/$theme_id";
				}
				
				function bm_gallery_log($entry)
				{
				 			   global $bm_gallery_log;
								$bm_gallery_log .= date("H:i:s") . " - " . $entry . "<br>\n";				 
				}
				
				function bm_gallery_download_logshow($msg)
				{
				 			   global $bm_gallery_log;
								bm_gallery_topbarmessage( $msg . "<br><pre>" . $bm_gallery_log . "</pre>");
				}
				
				function bm_gallery_download()
				{
				 				 $url = $_POST["url"];

								 bm_gallery_log(__("Start Download of Theme from $url",'bm_themegallery'));
								 
								 $tmpdir = BM_GALLERY_TEMP;
								 $dest = tempnam ($tmpdir, "bm_gallery");
 								 bm_gallery_log(__("Creating temporary file $dest in $tmpdir",'bm_themegallery'));
								 
								 // copy might be restricted -- not all PHP installations will allow
								 // http download through copy 
								 if (copy ( $url, $dest ))
								 {
   								 bm_gallery_log(__("Succesfully downloaded $url",'bm_themegallery'));
									 $result = bm_gallery_handlefile(basename($url),$dest);
								 }
 								 else
								   bm_gallery_download_logshow( __("Error downloading file $url",'bm_themegallery') );

 								 bm_gallery_log(__("Removing temporary file",'bm_themegallery') . " " .  $dest );
  							    unlink( $dest );
								 
								 return $result; 
				}
				
				function bm_gallery_upload()
				{
				 				 if ($_FILES['userfile']['error']>0) 
								 {  
								 		bm_gallery_log(__("No file was uploaded?",'bm_themegallery'));
  								 	   bm_gallery_download_logshow( __("Upload Error",'bm_themegallery') );
										return false; 
								 } 
								
				 				$dest = $_FILES['userfile']['tmp_name'];
								$filename = basename($_FILES['userfile']['name']);
								
						 		bm_gallery_log(__("Upload received",'bm_themegallery') . "tmp = $dest; filename= $filename");
						      return bm_gallery_handlefile($filename,$dest);								
				}
				
				
				function bm_gallery_handlefile($filename,$dest)
				{
									 // Handle the zip file 
									 $zipFile = new PclZip($dest);
									 									  				
				
									 // Now determine the contents of the style.css file
									 $theme = bm_gallery_download_decode_style_css($zipFile); 
									 if ($theme == false )
									 {
								 	   bm_gallery_download_logshow( __("Error retrieving style.css file from theme.",'bm_themegallery') );
									   return false;
									 }
									 
									 // Add the information to the database
									 $theme["Filename"] = basename($filename);
									 $theme_id = bm_gallery_db_inserttheme($theme);
									 
									 if ($theme_id == 0) {
								 	   bm_gallery_download_logshow( __("Error inserting the theme into the database.",'bm_themegallery') );
									   return false;
									 }
									 
									 // Copy the zip file to a location of its own 
									 if (!bm_gallery_download_copytofinal($filename,$dest, $theme_id))
									 {
								 	   bm_gallery_download_logshow( __("Error moving the theme to its destination",'bm_themegallery') );
										 bm_gallery_db_deletetheme($theme_id);
										 return false; 
									 }
									 
									 // Extract the screenshot from the theme, and put it into the same directory
									 if (!bm_gallery_download_extractthumb($filename,$zipFile,$theme_id))
									 {
								 	   bm_gallery_download_logshow( __("Error extracting the theme thumbnail",'bm_themegallery') );
										bm_gallery_delete_themedir($theme,$theme_id);
										bm_gallery_db_deletetheme($theme_id);										 
										return false; 
									 }
									 
									 // Attempt to create a smaller thumb for use in the gallery 
									 if (!bm_gallery_download_resizethumb($theme_id))
									 {
								 	   bm_gallery_download_logshow( __("Error resizing the theme thumbnail",'bm_themegallery') );
										 bm_gallery_delete_themedir($theme,$theme_id);										 
										 bm_gallery_db_deletetheme($theme_id);										 
										 return false; 
									 }									 
		
							 	   bm_gallery_topbarmessage( __("Theme download completed & added to the collection",'bm_themegallery') );

								return true;    
				}
				
				function bm_gallery_download_decode_style_css($zipFile)
				{
								 // Look for the style.css file, and return the contents 
				 				 $results = $zipFile->extract(PCLZIP_OPT_BY_PREG,'/style\.css/',PCLZIP_OPT_EXTRACT_AS_STRING);
								 
								 // If no style.css is found, we abort here 
								 if (!is_array($results))
									  return false;
										
								 // Now parse the style sheet contents 
								 $theme = bm_scanner_get_theme_data( $results[0]['content'] );
								 
								 // If we are unable to parse the information completely , we need to fill in 
								 // a temporary name 
								 if ($theme['Name']=="") $theme['Name'] = __("Theme without name",'bm_themegallery');
								 									
								 return $theme; 		
				} 
				
				// bm_gallery_download_copytofinal
				//
				// Copy the temporary file to a new directory 
				
				function bm_gallery_download_copytofinal($name,$tempfile,$theme_id)
				{
				 				 // Determine the destination directory 
								 $destdir = BM_GALLERY_DIRECTORY . "/$theme_id";
				
				 				 // Create a directory to store the theme file in
								 if (!@mkdir( $destdir ))
								 {
							 		bm_gallery_log(__("Unable to create directory",'bm_themegallery' ) ." " . $destdir,'bm_themegallery');
									return false;
								 }

								 // Copy the file to the final location
								 if (!copy ( $tempfile , $destdir . '/' . $name )) 
								 {
 							 		bm_gallery_log(__("Error copying ",'bm_themegallery') . $tempfile . ' -> ' . $destdir . '/' . $name );
									return false;
								 }
									
								 // Success
								 return true;  
				}
				
				// bm_gallery_download_extractthumb
				//
				// Extract the thumbnail from the theme zip file  
				
				function bm_gallery_download_extractthumb($name,$zipFile,$theme_id)
				{
				 				 // Determine the destination directory 
								 $destdir = bm_gallery_getthemedir($theme_id);
								 
 								 // Look for the style.css file, and return the contents 
				 				 $results = $zipFile->extract(PCLZIP_OPT_BY_PREG,'/screenshot\.(png|jpg)/',PCLZIP_OPT_REMOVE_ALL_PATH,PCLZIP_OPT_PATH,$destdir);
								 
								 if (!is_array($results) || $results[0]['status'] != "ok")								 
								 {
									  bm_gallery_log(__("Error locating screenshot.png / screenshot.jpg",'bm_themegallery') . " (" . $results[0]['status'] . ")" );
								 print_r($results);
									  return false;
								 }

								 
								 bm_gallery_log(__("Extracted screenshot.png / screenshot.jpg",'bm_themegallery') );								 

								 return true;
				}
				
				function bm_gallery_download_resizethumb($theme_id)
				{
				 				 // Determine the theme directory 
								 $theme_dir = bm_gallery_getthemedir($theme_id);
								 
								 // Now try to open the screenshot.png file 
								 $screenshot_png = $theme_dir . "/screenshot.png";
								 $screenshot_jpg = $theme_dir . "/screenshot.jpg";
								 $thumbname  = $theme_dir . "/thumb.png";
								 
								 // We need to support GD for this to work
								 if (file_exists($screenshot_png))
								 {
								  $im = imagecreatefrompng($screenshot_png);
								  $sourceisjpg = false;
								 }
								 else
								  if (file_exists($screenshot_jpg))
								  {
								   $im = imagecreatefromjpeg($screenshot_jpg);
								   $sourceisjpg = true;
								  }
								  else
								  {								    
								    bm_gallery_log(__("Error while opening screenshot file (jpg/png)",'bm_themegallery') );
								    return false;
								  }
								  
								 // The smaller (bandwidth saving) thumb version
								 $im_thumb = imagecreatetruecolor(150, 113);
								 imagecopyresampled( $im_thumb, $im , 0,0, 0,0,150,113,imagesx($im),imagesy($im));
								 
								 // Save the file to disk 
								 imagepng($im_thumb , $thumbname);
						       bm_gallery_log($thumbname  . __(' created','bm_themegallery') );
						       
								 // To "simplify" things, if the theme contained a JPG we will 
								 // create out own PNG to ensure that we have the right image
								 // in place 
								 
								 if ($sourceisjpg)
								 {
								    imagepng($im , $screenshot_png);
						          bm_gallery_log($screenshot_png . __(' created because theme contained JPG','bm_themegallery') );
								 }						       
								 
								 return true; 
				}
				
				// bm_gallery_delete_themedir
				//
				// This removes the directory and all files we created 
				
				function bm_gallery_delete_themedir($theme,$theme_id)
				{
				 				// Find the theme directory 
								$dir = bm_gallery_getthemedir($theme_id);
							
								// Empty the directory
								$thumb = $dir . "/thumb.png"; 
								if (file_exists($thumb)) unlink ($thumb);
								$screenshot_png = $dir . "/screenshot.png";
								if (file_exists($screenshot_png)) unlink ($screenshot_png);
								$screenshot_jpg = $dir . "/screenshot.jpg";
								if (file_exists($screenshot_jpg)) unlink ($screenshot_jpg);								

								if ($theme["theme_filename"]) $zip = $dir . "/" . $theme["theme_filename"];
								else $zip = $dir . "/" . $theme["Filename"];
								if (file_exists($zip)) unlink ($zip);
								
								// Now remove it -- this fails if the directory is not empty
								if (file_exists($dir)) rmdir($dir);
				}
				
				
?>