<?php 

			// home.php
			//
			// This is the home page for the theme gallery ; it allows you to add 
			// browse and search the themes we have collected
			
			function bm_gallery_home_show($content)
			{
			 			global $bm_gallery_theme_id;

						$home = "";
						
						if ($bm_gallery_theme_id)
						 $home .= bm_gallery_home_showdetail();  
						else
						{
						 // Show the themes that match the current search 
 		 			    $filter = $_POST["f"];
						 $page = intval($_GET["gp"]); 
						 $home .= bm_gallery_home_showthemes($filter,$page);
						}  						 	 

						// Return the results 						
						$content = $content . $home; 
			 			return $content; 
			}
			
			function bm_gallery_home_navigation($page,$max)
			{
			
						$out = "<div class='gallery_nav'>\n";
						$filter = $_POST["f"];
						if ($filter) 
						  foreach($filter as $value)
						    $selfilter .= "&f%5B%5D=$value";

						if ($page>0) 
						{ 
						  $prev = $page - 1;
						  $out .= "<a href='?gp=$prev$selfilter'>" . __("prev",'bm_themegallery') . "</a>";
						}

						$out .= sprintf(" %s %d ",__('Page', 'bm_themegallery'), ($page+1)); 
						
						if ($page<ceil($max/BM_GALLERY_MAXPERPAGE)-1) 
						{
							$next = $page + 1;
							$out .= "<a href='?gp=$next$selfilter'>" . __("next",'bm_themegallery') . "</a>";
						}
						
						$out .= "</div>\n";
						
						return $out;
			}			
			
			
			function bm_gallery_home_showthemes($filter,$page)
			{
			 		 // Retrieve a subset of themes
					 $list = bm_gallery_db_getselectedthemes($filter,$page); 

					 if (!empty($list))
					 {
					   $out .= "<div class='gallery_searchresult'>"; 
						 
						 // Some logic for handling the search result page numbering
						 $max = bm_gallery_db_getnummatches($filter);
						 $out .= sprintf("%s %d %s ",__("Found",'bm_themegallery'),$max,__(" matche(s), showing")); 
						 
						 if ($page<=0) $page = 0;
						 $start = ($page * BM_GALLERY_MAXPERPAGE)+1;
						 $end   = min( (($page+1) * BM_GALLERY_MAXPERPAGE) , $max );
						 $out .= sprintf(" %d %s %d",$start,__("to",'bm_themegallery'),$end); 
						 $out .= "</div>";
						 
						 $out .= bm_gallery_home_navigation($page,$max);						 
						 
						 foreach($list as $row) 
						 {
						    $out .= "<div class=gallery_item>";
							 $out .= "<div class=gallery_item_image>";
							 
							 $image = bm_gallery_url() . '/' . $row['theme_id'] . '/thumb.png';
							 
							 
							 // Fix to make this work on numbered url's
							 if (strpos($_SERVER['REQUEST_URI'],'?'))
							   $url = $_SERVER['REQUEST_URI'] . "&d=" . $row['theme_id'];
							 else
							   $url = "?d=" . $row['theme_id'];

							 
							 $out .= "<a href='$url'>";
							 $out .= "<img src='$image' border=0 alt='" .$row["theme_name"] . "' title='" . $row["theme_name"] . "' />";
							 $out .= "</a>";  
							 $out .= "</div>";
							 
							 $out .= "<div class=gallery_item_title><center>"; 
						    $out .= $row["theme_name"];
							 $out .= "</center></div>";
							 
							 $out .= "</div>";
						 }
						 
						 $out .= bm_gallery_home_navigation($page,$max);	
						 					 
						 
					 }
					 else
					 {
					   $out .= "<strong>" . __("No Themes Found for your criteria!") . "</strong>";
					 }

					 // Promote the plugin 					 
					 $out .= "<small><a href='http://blogmechanics.net'>BM Theme Gallery Plugin</a></small>";
					 
					 return $out; 
			}
			
			// bm_gallery_home_showdetail
			//
			// Show the details for a particular theme
			
			function bm_gallery_home_showdetail()
			{
			 		global $bm_gallery_theme;
			
			      /* Load the theme into memory */
   				if (empty($bm_gallery_theme) || $bm_gallery_theme['theme_active']==0)
					  return __("Error: unable to find the requested theme!",'bm_themegallery');
					
					/* Return to the index page */
					$tmp_pos = strpos($_SERVER['REQUEST_URI'],'&d');
					if ($tmp_pos)
					  $index = substr($_SERVER['REQUEST_URI'],0,$tmp_pos);
					else
					  $index = "?"; 					
					
					
					/* Load the themes options into memory */
					$out .= "<div class='gallery_themedetail'>";
					$out .= "<H3>" . $bm_gallery_theme["theme_name"] . "</H3>";
 				   $out .= "<div class='gallery_searchresult'>"; 
					$out .= "<a href='$index'>" . __("Return to Index",'bm_themegallery') . "</a>";
					$out .= "</div>";	
				   $image = bm_gallery_url() . '/' . $bm_gallery_theme['theme_id'] . '/screenshot.png';
 				   $out .= "<img src='$image' width=300 height=255 border=0 alt='" .$row["theme_name"] . "' title='" . $row["theme_name"] . "' />";

					$themeurl = $bm_gallery_theme['theme_uri'];
					if ($bm_gallery_theme['theme_author_uri'])
					 $author = '<a href="' . $bm_gallery_theme['theme_author_uri'] . '">' . $bm_gallery_theme['theme_author'] . '</a>';
				   else 
					 $author = $bm_gallery_theme['theme_author']; 
					
					$out .= "<table class='gallery_detail_table'>";
					$out .= "<tr><td>" . __("Theme Name",'bm_themegallery') . "</td><td>" . $bm_gallery_theme['theme_name'] . "</td></tr>";
					$out .= "<tr valign=top><td>" . __("Description",'bm_themegallery') . "</td><td>" . html_entity_decode($bm_gallery_theme['theme_description']) . "</td></tr>";
					$out .= "<tr><td>" . __("URI",'bm_themegallery') . "</td><td><A HREF='$themeurl'>" . $bm_gallery_theme['theme_uri'] . "</A></td></tr>";
					$out .= "<tr><td>" . __("Author",'bm_themegallery') . "</td><td>" . $author . "</td></tr>";
					$out .= "<tr><td>" . __("Version",'bm_themegallery') . "</td><td>" . $bm_gallery_theme['theme_version'] . "</td></tr>";
					$out .= "</table>";
					
					$out .= "<P>" . $bm_gallery_theme['theme_notes'] . "</P>";

					$url = bm_gallery_url() . '/' . $bm_gallery_theme['theme_id'] . '/' . $bm_gallery_theme['theme_filename'];					
					$out .= "<input type=button name=download_button value='" . __("Download",'bm_themegallery') . "' onClick='document.location=\"$url\"' />";
					$out .= "</div>";															

					return $out; 			
			}
			
?>