<?php
/*
Plugin Name: Blog Mechanics Theme Gallery
Plugin URI: http://blogmechanics.net/plugin-bm_themegallery/#
Description: A gallery for when one wordpress theme isn't enough, and you would like to store hundreds.  
Author: blogmechanic,2jgallery
Version: 1.3.3
Author URI: http://blogmechanics.net/#
*/

/* Welcome to the theme gallery plugin. I hope you like it, do feel free to 
 * send me suggestions, fixes etc and I will keep it up to date. 
 *
 * For changes see the changelog.txt file 
 *
 * For installation see the readme.txt file 
*/
 
/* Include required files */ 

require_once("scanner.php");
require_once("db.php");
require_once("optionspage.php");
require_once("download.php");
require_once("home.php");
require_once("widget.php");



if (!defined('PCLZIP_READ_BLOCK_SIZE')) 
{
    require_once("pclzip.lib.php");
}




define ( BM_GALLERY_NAME      , 'BM Gallery' );
define ( BM_GALLERY_WIDGET    , 'BM Gallery Options' );
define ( BM_GALLERY_KEY       , 'bm_gallery_key');
define ( BM_GALLERY_VERSION   , 10 );
define ( BM_GALLERY_DIRECTORY , ABSPATH . 'wp-content/bm_gallery');
define ( BM_GALLERY_MAXPERPAGE, 9 );
define ( BM_GALLERY_TITLESEP  , ' &raquo; ' );
define ( BM_GALLERY_TEMP		, '/tmp');

/* If you use the Google Sitemap plugin, set these constants */
define ( BM_GALLERY_SITEMAP   , false ); 									  // change to true
define ( BM_GALLERY_URL 	   , 'http://blogmechanics.net/themes'); // change to your sites url

// To change this value, you need to recreate the bm_gallery_options table, or modify the table by hand
define ( BM_GALLERY_MAXOPTIONS, 30 );  

function bm_gallery_activate()
{
				 // Check if we are already installed, if not install the required database tables
				 $version = get_option(BM_GALLERY_KEY);

				 // Check if we are not yet installed properly 
				 if ($version == false)
				 {
				 	  // Install database tables -- only if necessary
						bm_gallery_db_setup();
						
						// Create a directory to store the themes in 
						mkdir( $_SERVER['DOCUMENT_ROOT'] . BM_GALLERY_DIRECTORY , 0777  , false ); 
						
						// We are up to date 
						update_option(BM_GALLERY_KEY,BM_GALLERY_VERSION);
				 }

				 return true;
}

function bm_gallery_deactivate()
{
 				 delete_option(BM_GALLERY_KEY);
				 return true;				 
}

// bm_gallery_preheader
//
// This routine is called when Wordpress is about to display a post
// We need to detect if this is one of "our" pages 

function bm_gallery_preheader()
{
   global $bm_gallery_show;
	global $bm_gallery_theme;
	global $bm_gallery_theme_id;
	 
	$post_holder = 0; 

	/* At this point we determine the name of the current page */
	$post = &get_post($post_holder);
	
	/* Is this the home page for the gallery ? */ 
	if (get_post_meta($post->ID, "bm_gallery_home", true))
	{
	  /* We are in a content page attached to the gallery */ 
		add_filter('the_content','bm_gallery_home_show');
		$bm_gallery_show = true;
		
		/* We need to modify the title -- hence at this point we need to decide */
		/* what theme is being shown 	 						 							 	*/
		
		if (!$_POST["f"])
		{
		 $bm_gallery_theme_id = intval($_GET["d"]);
		 if ($bm_gallery_theme_id)
		 {
		  	 $bm_gallery_theme = bm_gallery_db_load($bm_gallery_theme_id);
			 if (!empty($bm_gallery_theme) && $bm_gallery_theme['theme_active']!=0)
					add_filter('single_post_title','bm_gallery_title');
		 }
		} 
		
	}
	else
		$bm_gallery_show = false;

}

// bm_gallery_title
// 
// Add the name of the theme to the title tag if we are zoomed in 

function bm_gallery_title($content)
{
				 global $bm_gallery_theme;
				 return $content . BM_GALLERY_TITLESEP . attribute_escape(strip_tags(html_entity_decode($bm_gallery_theme['theme_name'], ENT_QUOTES)));
}


function bm_gallery_admininit()
{
				 // Add a page to the options section of the website
				if (current_user_can('manage_options')) 				
 				 add_options_page(BM_GALLERY_NAME,BM_GALLERY_NAME, 8, __FILE__, 'bm_gallery_optionpage_show');
				 
}

function bm_gallery_topbarmessage($msg)
{
				 echo '<div class="updated fade" id="message"><p>' . $msg . '</p></div>';
}

function bm_gallery_url()
{
 				 return get_bloginfo('wpurl') . "/wp-content/bm_gallery/";
}

function bm_gallery_adminhomeurl()
{
 				 return get_bloginfo('wpurl') . "/wp-admin/options-general.php?page=" . __FILE__;
 				 // wp-admin/options-general.php?page=/home/nis/martijn/software/bm_themegallery/trunk/main.php
}

// bm_gallery_widget_style
//
// If the widget is shown, we need to add our own style sheet info			
function bm_gallery_style()
{
			  global $bm_gallery_show;
			
			  // This widget is only show if we are in the catalogue pages 
		    if (!$bm_gallery_show) return;
			
				?>
<style type="text/css">
			 .gallery_optionlist { border: 1px solid gray; padding: 2px;  }
 		    .gallery_option { width: 120px; float: left; font-size: 10px; }
			 .gallery_optiontitle { font-weight: bold; }
			 .gallery_optionlist ul { list-style-type: none; } 
			 .gallery_item { width: 155px; height: 150px; overflow: hidden; float: left; border: 1px solid gray; padding: 10px; margin: 0px 5px 15px 0px; }
			 .gallery_item_title { font-weight: bold;  } 
			 .gallery_item_image img { width: 150px; height: 113px; }
			 .gallery_searchresult { border-top: 1px solid gray; border-bottom: 1px solid gray; margin-right: 5px; margin-bottom: 5px; }
			 .gallery_detail_table { border: 1px solid gray; margin-top: 25px; width: 99%; }
			 .gallery_nav { clear: both; border-top: 1px solid gray; border-bottom: 1px solid gray; margin-right: 5px; margin-bottom: 5px; }
</style>
		  	<?php
}	

/* bm_gallery_international
 *
 * Simply loads the internationalisation data into memory 
*/

function bm_gallery_international()
{
	load_plugin_textdomain('bm_themegallery', PLUGINDIR . '/bm_themegallery');
}


	
function bm_gallery_sitemap() 
{
	$generatorObject = &GoogleSitemapGenerator::GetInstance(); //Please note the "&" sign!
	if($generatorObject!=null) 
	{
	 	 // Get a listing of all the active themes in the database
		 $active_themes = bm_gallery_db_getallactive();
		 if ($active_themes)
 		  foreach ($active_themes as $row) 
			  $generatorObject->AddUrl(BM_GALLERY_URL . '?d=' . $row['theme_id'],time(),"weekly",0.4);
	}
}

/* If active, setup the sitemap hook */	
if (BM_GALLERY_SITEMAP)
 add_action("sm_buildmap","bm_gallery_sitemap");

/* Tie the module into Wordpress */
add_action('init','bm_gallery_international');
add_action('admin_menu','bm_gallery_admininit');
add_action('get_header', 'bm_gallery_preheader');
add_action('wp_head', 'bm_gallery_style');
register_activation_hook(__FILE__, 'bm_gallery_activate');
register_deactivation_hook(__FILE__, 'bm_gallery_deactivate');


?>