<?php 

			// scanner.php
			// 
			// Routines for decoding a new theme file before adding it to the database
			//

			// wordpress get_theme_data function 
			//
			// Modified to avoid it from adding the author_uri to the author string
			
			function bm_scanner_get_theme_data( $stylecss ) {
	$themes_allowed_tags = array(
		'a' => array(
			'href' => array(),'title' => array()
			),
		'abbr' => array(
			'title' => array()
			),
		'acronym' => array(
			'title' => array()
			),
		'code' => array(),
		'em' => array(),
		'strong' => array()
	);

	$theme_data = $stylecss; // implode( '', file( $theme_file ) );
	$theme_data = str_replace ( '\r', '\n', $theme_data );
	preg_match( '|Theme Name:(.*)$|mi', $theme_data, $theme_name );
	preg_match( '|Theme URI:(.*)$|mi', $theme_data, $theme_uri );
	preg_match( '|Description:(.*)$|mi', $theme_data, $description );
	preg_match( '|Author:(.*)$|mi', $theme_data, $author_name );
	preg_match( '|Author URI:(.*)$|mi', $theme_data, $author_uri );
	preg_match( '|Template:(.*)$|mi', $theme_data, $template );

	if ( preg_match( '|Version:(.*)|i', $theme_data, $version ) )
		$version = wp_kses( trim( $version[1] ), $themes_allowed_tags );
	else
		$version = '';

	if ( preg_match('|Status:(.*)|i', $theme_data, $status) )
		$status = wp_kses( trim( $status[1] ), $themes_allowed_tags );
	else
		$status = 'publish';

	$name = $theme = wp_kses( trim( $theme_name[1] ), $themes_allowed_tags );
	$theme_uri = clean_url( trim( $theme_uri[1] ) );
	$description = wptexturize( wp_kses( trim( $description[1] ), $themes_allowed_tags ) );
	$template = wp_kses( trim( $template[1] ), $themes_allowed_tags );

	$author_uri = clean_url( trim( $author_uri[1] ) );

	/*if ( empty( $author_uri[1] ) ) {*/
		$author = wp_kses( trim( $author_name[1] ), $themes_allowed_tags );
  /*	} else {
		$author = sprintf( '<a href="%1$s" title="%2$s">%3$s</a>', $author_uri, __( 'Visit author homepage' ), wp_kses( trim( $author_name[1] ), $themes_allowed_tags ) );
	}*/

	return array( 'Author_URI' => $author_uri, 'Name' => $name, 'Title' => $theme, 'URI' => $theme_uri, 'Description' => $description, 'Author' => $author, 'Version' => $version, 'Template' => $template, 'Status' => $status );
}

			

?>